#!/bin/sh

##############################################################################
#                                                                             #
#   Product name:   load_LaserJet_firmware (foo2zjs helper)                   #
#        version:   3-3 -- May 13, 2007                                       #
#                                                                             #
#	Copyright 2007 Matt Broughton <walterwego@macosx.com>                     #
#                                                                             #
#   This program is freed software; you can redistribute it and/or modify it  #
#   under the terms of the GNU General Public License as published by the Free#
#   Software Foundation; either version 2 of the License, or (at your option) #
#   any later version.                                                        #
#                                                                             #
#   This program is distributed in the hope that it will be useful, but       #
#   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY#
#   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License  #
#   for more details.                                                         #
#                                                                             #
#   You should have received a copy of the GNU General Public License         #
#   along with this program; if not, write to the Free Software               #
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.#
#                                                                             #
#                                                                             #
###############################################################################

#set -x
IFS="
"
# set the CUPS ppd directory variable
CUPS_PPD_DIR="/etc/cups/ppd/"
# the qualifying HP LaserJet models that need firmware.
MODEL_KEY=(1000 1005 1018 1020)
# Get all needed info from lpstat.
PRINTER_INFO=(`lpstat -v`)
## Keep track which URIs are used when firmware sent.
##  We only need to send firmware to the printer once.
##  There may be more than one queue per URI.
URI_SENT=(  )
for DEVICE in ${PRINTER_INFO[@]}
do
## We will get printer name for parsing PPDs and the 
## device URI from lpstat.
NAME=`echo $DEVICE | awk '{split($3,a,":");print a[1];}'`
printf "\nPrinter ${NAME}:\n"
##No need to make extra work for ourselves.
##Do a rough test to see if we have a qualified printer that
## needs firmware.
cat ${CUPS_PPD_DIR}${NAME}.ppd | grep -q "HP\ LaserJet.*foo2zjs"
	PREQUALIFY=$?
	#echo match or no $PREQUALIFY
if [ ${PREQUALIFY} -eq 0 ] ; then
#echo "We have a match."
URI=`echo ${DEVICE} | awk '{print$4;}'`
#echo ${URI}
	for i in ${MODEL_KEY[@]}
	do
	#echo "${CUPS_PPD_DIR}${NAME}.ppd"
	cat ${CUPS_PPD_DIR}${NAME}.ppd | grep -q "HP\ LaserJet\ $i\ foo2zjs"
	QUEUE_MATCH=$?
	#echo match or no $QUEUE_MATCH
	if [ ${QUEUE_MATCH} -eq 0 ] ; then
	#echo "We have a match."
	#echo "QUEUE is ${QUEUE}:"
	##Has firmware already been sent?
	#set -x
	echo ${URI_SENT[@]} | grep -q "${URI}"
	YORN=$?
		if [ ${YORN} -eq 1 ] ; then
		URI_SENT=( "${URI_SENT[@]}" "${URI}" )
			if [ -r /usr/local/share/foo2zjs/firmware/sihp$i.dl ] ; then
			echo "Sending HP LaserJet $i firmware to  printer ${NAME} . . ."
			echo "lp -d ${NAME} -oraw /usr/local/share/foo2zjs/firmware/sihp$i.dl"
			lp -d ${NAME} -oraw /usr/local/share/foo2zjs/firmware/sihp$i.dl
			else
				if [ -r /usr/share/foo2zfs/firmware/sihp$i.dl ] ; then
				echo "Sending HP LaserJet $i firmware to  printer ${NAME} . . ."
		    	echo "lp -d ${NAME} -oraw /usr/local/share/foo2zjs/firmware/sihp$i.dl"
				lp -d ${NAME} -oraw /usr/local/share/foo2zjs/firmware/sihp$i.dl
				else
				echo "Cannot locate firmware file."
				fi
			fi
			else
			printf "Firmware already sent to this printer's URI.  No need to send again.\n"
		fi
	else 
	echo "No printer queue found for HP LaserJet $i."
	fi
done

else
printf "Not a qualifying HP LaserJet printer.\n"
fi

done



#printf "\n\n\nNubmer in URI_SENT=${#URI_SENT[@]}\n\n"
#echo "${URI_SENT[@]}"